"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateQueries = void 0;
var fs_extra_1 = require("fs-extra");
var query_hook_content_1 = require("./content/query-hook-content");
var generate_gql_query_1 = require("./gql-query/generate-gql-query");
var capitalize_1 = require("../../util/capitalize");
var generateQueries = function (fields, fetcher, outputPath, selectors) { return __awaiter(void 0, void 0, void 0, function () {
    var fields_1, fields_1_1, query, regex, selector, selectorType, selectorValue, type, variables, queryKeyVariables, variablesArgument, variablesBinding, argsTypeImport, argstypeName, data, e_1_1;
    var e_1, _a;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4 /*yield*/, (0, generate_gql_query_1.generateGqlQuery)(fetcher, outputPath)];
            case 1:
                _c.sent();
                if (fields === null) {
                    return [2 /*return*/];
                }
                _c.label = 2;
            case 2:
                _c.trys.push([2, 7, 8, 9]);
                fields_1 = __values(fields), fields_1_1 = fields_1.next();
                _c.label = 3;
            case 3:
                if (!!fields_1_1.done) return [3 /*break*/, 6];
                query = fields_1_1.value;
                regex = new RegExp("^".concat(query.name, "\\?: {(.*)}$"), 'm');
                selector = (_b = regex.exec(selectors.querySelector)) === null || _b === void 0 ? void 0 : _b[1];
                selectorType = selector === null || selector === void 0 ? void 0 : selector.replace(/\?: /g, ': ');
                selectorValue = selector === null || selector === void 0 ? void 0 : selector.replace(/\?: boolean;/g, ': true,').replace(/\?: {/g, ': {').replace(/};/g, '},');
                type = (0, capitalize_1.capitalize)(query.name);
                variables = '';
                queryKeyVariables = '';
                variablesArgument = '';
                variablesBinding = '';
                argsTypeImport = '';
                if (query.args && query.args.length > 0) {
                    argstypeName = "".concat(type, "QueryArgs");
                    variables = ", variables";
                    queryKeyVariables = ', ...Object.values(variables)';
                    variablesArgument = "variables: ".concat(argstypeName, ",");
                    argsTypeImport = "import { ".concat(argstypeName, " } from '../types/api-types';\n");
                    variablesBinding = ".bind(null, variables)";
                }
                data = query_hook_content_1.queryHookContent
                    .replace(/#variables#/g, variables)
                    .replace(/#variables-argument#/g, variablesArgument)
                    .replace('#args-type-import#', argsTypeImport)
                    .replace('#query-key-variables#', queryKeyVariables)
                    .replace('#variables-binding#', variablesBinding)
                    .replace('#fetcher-hook-import#', "import { ".concat(fetcher.functionName, " } from '").concat(fetcher.path, "';"))
                    .replace('#fetcherFn#', "".concat(fetcher.functionName))
                    .replace('#full-selector-type#', selectorType || '')
                    .replace('#full-selector#', selectorValue || '')
                    .replace(/#type#/g, type)
                    .replace(/#name#/g, query.name);
                return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/queries/use").concat(type, "Query.ts"), data)];
            case 4:
                _c.sent();
                _c.label = 5;
            case 5:
                fields_1_1 = fields_1.next();
                return [3 /*break*/, 3];
            case 6: return [3 /*break*/, 9];
            case 7:
                e_1_1 = _c.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 9];
            case 8:
                try {
                    if (fields_1_1 && !fields_1_1.done && (_a = fields_1.return)) _a.call(fields_1);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 9: return [2 /*return*/];
        }
    });
}); };
exports.generateQueries = generateQueries;
