"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.translateGraphqlTypesToTypescript = void 0;
var parse_graphql_object_1 = require("./object-parsing/parse-graphql-object");
var translateGraphqlTypesToTypescript = function (input) {
    var count = 0;
    var rootObjectsName = [];
    var typesObject = {};
    var argsTypesObject = {};
    var enums = [];
    var argsTypesOutput = '';
    var output = input.reduce(function (acc, _a) {
        var kind = _a.kind, name = _a.name, fields = _a.fields, inputFields = _a.inputFields, enumValues = _a.enumValues;
        if (name.startsWith('__')) {
            return acc;
        }
        if (kind === 'OBJECT' || kind === 'INPUT_OBJECT') {
            rootObjectsName.push(name);
            var target = kind === 'OBJECT' ? fields : inputFields;
            var _b = (0, parse_graphql_object_1.parseGraphqlObject)(name, target), argsTypes = _b.argsTypes, output_1 = _b.output, argsCount = _b.argsCount, t = _b.typesObject, at = _b.argsTypesObject;
            if (name !== 'Query' && name !== 'Mutation') {
                typesObject[name] = t;
            }
            acc += output_1;
            argsTypesOutput += argsTypes;
            argsTypesObject = __assign(__assign({}, argsTypesObject), at);
            count += argsCount + 1;
        }
        else if (kind === 'ENUM') {
            enums.push(name);
            var typeOutput = "export type ".concat(name, " = ").concat(enumValues === null || enumValues === void 0 ? void 0 : enumValues.map(function (v) { return "'".concat(v.name, "'"); }).join(' | '));
            acc += "".concat(typeOutput, ";\n");
            count++;
        }
        return acc;
    }, '');
    return {
        types: "/* eslint-disable */\n/* tslint:disable */\n\n".concat(output, "\n").concat(argsTypesOutput),
        typesObject: __assign(__assign({}, typesObject), argsTypesObject),
        count: count,
        rootObjectsName: rootObjectsName,
        enums: enums,
    };
};
exports.translateGraphqlTypesToTypescript = translateGraphqlTypesToTypescript;
