"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.booleanizeTypes = void 0;
var console_messages_1 = require("../../../cli/console/console.messages");
var objectPropertiesRegex = function (name, output) {
    var _a;
    return (_a = new RegExp("".concat(name, " ({[\\s\\S]*?})"), 'gm')
        .exec(output)) === null || _a === void 0 ? void 0 : _a[1].replace(/\s/g, '').slice(1, -1);
};
var propertyTypeRegex = /:.*/g;
var stripArrayRegex = /Array<(.*)>/;
var booleanizeTypes = function (name, types, objectsName, booleanize, depth) {
    var _a;
    if (depth === void 0) { depth = 0; }
    var properties = (_a = objectPropertiesRegex(name, types)) === null || _a === void 0 ? void 0 : _a.split(';').filter(function (el) { return el.length > 0; });
    if (!properties) {
        return '';
    }
    var output = properties.reduce(function (acc, property) {
        var _a, _b;
        var _c = __read(property.split(':'), 2), name = _c[0], type = _c[1];
        var array = !booleanize && type.startsWith('Array<') ? '[]' : '';
        var rawType = (_b = (_a = stripArrayRegex.exec(type)) === null || _a === void 0 ? void 0 : _a[1]) !== null && _b !== void 0 ? _b : type;
        if (objectsName.includes(rawType)) {
            if (depth < 9) {
                return (acc +
                    ("".concat(name).concat(booleanize && !name.endsWith('?') ? '?' : '', ": ") +
                        (0, exports.booleanizeTypes)(rawType, types, objectsName, booleanize, ++depth) +
                        array +
                        ';'));
            }
            (0, console_messages_1.displayWarning)('Deeply nested type detected. Depth is limited to 9; falling back to type unknown');
            return "".concat(name, ": unknown");
        }
        return (acc +
            property.replace(propertyTypeRegex, booleanize ? '?: boolean; ' : ": ".concat(type).concat(array, "; ")));
    }, '');
    return "{ ".concat(output, " }");
};
exports.booleanizeTypes = booleanizeTypes;
