"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateQuerySelector = void 0;
var booleanize_types_1 = require("./booleanize-types");
var generateQuerySelector = function (queryObject, types, objectsName, booleanize) {
    var _a, _b;
    if (booleanize === void 0) { booleanize = true; }
    var fieldsOutput = (_b = (_a = queryObject.fields) === null || _a === void 0 ? void 0 : _a.reduce(function (output, _a) {
        var _b, _c, _d, _e;
        var name = _a.name, type = _a.type;
        var typeOutput = "".concat(name).concat(booleanize ? '?' : '', ": ");
        if (((_b = type.ofType) === null || _b === void 0 ? void 0 : _b.kind) === 'LIST') {
            typeOutput +=
                (0, booleanize_types_1.booleanizeTypes)((_d = (_c = type.ofType.ofType) === null || _c === void 0 ? void 0 : _c.ofType) === null || _d === void 0 ? void 0 : _d.name, types, objectsName, booleanize) + "".concat(booleanize ? '' : '[]', "\n");
        }
        else if (((_e = type.ofType) === null || _e === void 0 ? void 0 : _e.kind) === 'OBJECT') {
            typeOutput +=
                (0, booleanize_types_1.booleanizeTypes)(type.ofType.name, types, objectsName, booleanize) + '\n';
        }
        return output + typeOutput;
    }, '')) !== null && _b !== void 0 ? _b : '';
    return "export type QuerySelector".concat(booleanize ? '' : 'Result', " = {\n").concat(fieldsOutput, "}");
};
exports.generateQuerySelector = generateQuerySelector;
